#include <iostream>
#include <fstream>
#include <qmessagebox.h>
#include <qfile.h>
#include <qtimer.h>
using namespace std;


struct score {int puntuacio; char nom[10];} scores[3];

void genera_fitxer();
void llig_fitxer();

QSpinBox *valor[9][9];

QColor Blanc(255,255,255);
QColor Blau(240,240,240);

int dificultat=35;
int temps=-1;
int solucio[9][9];
int completat=0;
QTimer * counter; 

void genera_sudoku(int i, int j)
{
    int columna;
    int comprobacio[10];
    int probades[9];
    for (int cont=0;cont<9;cont++) probades[cont]=0;
    columna=rand()%9;
    while (1) {
	if (columna<8) columna+=1; else columna=0;
	comprobacio[0]=0;    
	while ((solucio[j][columna]!=0 or probades[columna]!=0) and comprobacio[0]<=9) {if (columna<8) columna+=1; else columna=0; comprobacio[0]++;}
	if (comprobacio[0]>=9) return;
	for (int k=0;k<=9;k++) comprobacio[k]=0;
	for (int k=0;k<9;k++) { comprobacio[solucio[j][k]]++; comprobacio[solucio[k][columna]]++; }
	int a=3,b=3;
	if (j<3) a=0; if (j>5) a=6;
	if (columna<3) b=0; if (columna>5) b=6;
	for (int k=a;k<a+3;k++) 
	    for (int m=b;m<b+3;m++) comprobacio[solucio[k][m]]++;
	probades[columna]++; 
	if (comprobacio[i]==0)  
	{
	    solucio[j][columna]=i; 
	    if (i==9 && j==8) completat=1;
	    if (completat!=0) break;
	    if (j<8) 
		genera_sudoku(i,j+1); 
	    else 
		genera_sudoku(i+1,0);
	    
	    if (completat==0) {solucio[j][columna]=0; }
	}
    }
    return;
}   

void Form2::comprobar()
{   
    for (int i=0;i<9;i++)
	for (int j=0;j<9;j++)
	    if (valor[i][j]->value()!=solucio[i][j])
	    {
	QMessageBox::critical(this, "Incorrect","There are wrong positioned numbers","Ok", 0,0,1);
	valor[i][j]->selectAll();
	return;
    }
    counter->stop();
    this->habilitar(false);
    QMessageBox::information(this, "Done!","Sudoku is now finished!","Ok", 0,0,1);
    int pos=0;
    for (pos=0;pos<3;pos++)
	if (((dificultat*(999-temps))/10)>scores[pos].puntuacio) break;
    for (int i=2;i>pos;i--)
    {
	scores[i].puntuacio=scores[i-1].puntuacio;
	for (int j=0;j<10;j++) scores[i].nom[j]=scores[i-1].nom[j];
    }
    char nomus[10];
    system("whoami>nom");
    ifstream nomusuari;
    nomusuari.open("nom");
    nomusuari.getline(nomus,10);  
    nomusuari.close();
    system("rm nom");
    scores[pos].puntuacio=(dificultat*(999-temps))/10;
    for (int j=0;j<10;j++) scores[pos].nom[j]=nomus[j];
    genera_fitxer();
}

void Form2::configura()
{
    
    switch(QMessageBox::question(this, "Configure","Select desired level:","Easy","Normal","Hard",0,-1))
    {
    case 0:
	dificultat=25;
	break;
    case 1:
	dificultat=35;
	break;
    case 2:
	dificultat=45;
	break;
    }
    
    
    this->iniciarJoc();
}


void Form2::quanta()
{
    QMessageBox::about(this, "About sudoku","Version Beta 0.3 by Victor Alamo victorpoplar@hotmail.com");
}

void Form2::actualitza()
{
    temps++;
    QString temp[2];
    temp[0].setNum(temps%60);
    if ((temps%60)<10) temp[0].prepend("0");
    temp[1].setNum(temps/60);
    if ((temps/60)<10) temp[1].prepend("0");
    temp[1]+":"+temp[0];
    this->textLabel1->setText("Time elapsed: "+temp[1]+":"+temp[0]);
}


void Form2::records()
{
    llig_fitxer();
    QString recordstr[4];
    for (int i=0;i<3;i++) 
    {
	recordstr[i].setNum(scores[i].puntuacio);
	recordstr[i].prepend("           ");
	recordstr[i].prepend(scores[i].nom);
	recordstr[i].append("\n");
	recordstr[3]+=recordstr[i];
    }
    QMessageBox::information(this, "Scores","Best Scores:\n\n"+recordstr[3],"Ok",0,0,1);    
}

void Form2::iniciarJoc()
{
    if (temps==-1) this->asignacioInicial();
    
    completat=0;
    for (int i=0;i<9;i++)
	for (int j=0;j<9;j++)
	    solucio[i][j]=0;
    
    srand(time(NULL));
    genera_sudoku(1,0);
    
    for (int i=0;i<9;i++) {
	for (int j=0;j<9;j++)
	{
	    valor[i][j]->setMinValue(solucio[i][j]);
	    valor[i][j]->setMaxValue(solucio[i][j]);
	    valor[i][j]->setValue(solucio[i][j]);
	    valor[i][j]->setEnabled(true);
	    valor[i][j]->setSpecialValueText(NULL);
	    valor[i][j]->setFont(QFont ( "Helvetica",12, QFont::Bold,FALSE));
	    valor[i][j]->setPaletteBackgroundColor(Blau);
	}
    }
    
    for (int i=0;i<dificultat;i++)
    {
	int a[2];
	a[0]=rand()%9;
	a[1]=rand()%9;
	valor[a[0]][a[1]]->setMinValue(0);
	valor[a[0]][a[1]]->setMaxValue(9);
	valor[a[0]][a[1]]->setSpecialValueText(" ");
	valor[a[0]][a[1]]->setValue(0);
	valor[a[0]][a[1]]->setFont(QFont ( "Helvetica",12));
	valor[a[0]][a[1]]->setPaletteBackgroundColor(Blanc);
    }
    
    if (temps==-1) 
    {
	counter = new QTimer( this );
	connect( counter, SIGNAL(timeout()),this, SLOT(actualitza()) );
    }
    counter->stop();
    counter->start( 1000 );   
    temps=0;
    this->habilitar(true);
}

void Form2::asignacioInicial()
{
    valor[0][0]=this->spinBox1;
    valor[0][1]=this->spinBox2;
    valor[0][2]=this->spinBox3;
    valor[1][0]=this->spinBox4;
    valor[1][1]=this->spinBox5;
    valor[1][2]=this->spinBox6;
    valor[2][0]=this->spinBox7;
    valor[2][1]=this->spinBox8;
    valor[2][2]=this->spinBox9;
    valor[0][3]=this->spinBox1_2;
    valor[0][4]=this->spinBox2_2;
    valor[0][5]=this->spinBox3_2;
    valor[1][3]=this->spinBox4_2;
    valor[1][4]=this->spinBox5_2;
    valor[1][5]=this->spinBox6_2;
    valor[2][3]=this->spinBox7_2;
    valor[2][4]=this->spinBox8_2;
    valor[2][5]=this->spinBox9_2;
    valor[0][6]=this->spinBox1_3;
    valor[0][7]=this->spinBox2_3;
    valor[0][8]=this->spinBox3_3;
    valor[1][6]=this->spinBox4_3;
    valor[1][7]=this->spinBox5_3;
    valor[1][8]=this->spinBox6_3;
    valor[2][6]=this->spinBox7_3;
    valor[2][7]=this->spinBox8_3;
    valor[2][8]=this->spinBox9_3;
    valor[3][0]=this->spinBox1_4;
    valor[3][1]=this->spinBox2_4;
    valor[3][2]=this->spinBox3_4;
    valor[4][0]=this->spinBox4_4;
    valor[4][1]=this->spinBox5_4;
    valor[4][2]=this->spinBox6_4;
    valor[5][0]=this->spinBox7_4;
    valor[5][1]=this->spinBox8_4;
    valor[5][2]=this->spinBox9_4;
    valor[3][3]=this->spinBox1_5;
    valor[3][4]=this->spinBox2_5;
    valor[3][5]=this->spinBox3_5;
    valor[4][3]=this->spinBox4_5;
    valor[4][4]=this->spinBox5_5;
    valor[4][5]=this->spinBox6_5;
    valor[5][3]=this->spinBox7_5;
    valor[5][4]=this->spinBox8_5;
    valor[5][5]=this->spinBox9_5;
    valor[3][6]=this->spinBox1_6;
    valor[3][7]=this->spinBox2_6;
    valor[3][8]=this->spinBox3_6;
    valor[4][6]=this->spinBox4_6;
    valor[4][7]=this->spinBox5_6;
    valor[4][8]=this->spinBox6_6;
    valor[5][6]=this->spinBox7_6;
    valor[5][7]=this->spinBox8_6;
    valor[5][8]=this->spinBox9_6;
    valor[6][0]=this->spinBox1_7;
    valor[6][1]=this->spinBox2_7;
    valor[6][2]=this->spinBox3_7;
    valor[7][0]=this->spinBox4_7;
    valor[7][1]=this->spinBox5_7;
    valor[7][2]=this->spinBox6_7;
    valor[8][0]=this->spinBox7_7;
    valor[8][1]=this->spinBox8_7;
    valor[8][2]=this->spinBox9_7;
    valor[6][3]=this->spinBox1_8;
    valor[6][4]=this->spinBox2_8;
    valor[6][5]=this->spinBox3_8;
    valor[7][3]=this->spinBox4_8;
    valor[7][4]=this->spinBox5_8;
    valor[7][5]=this->spinBox6_8;
    valor[8][3]=this->spinBox7_8;
    valor[8][4]=this->spinBox8_8;
    valor[8][5]=this->spinBox9_8;
    valor[6][6]=this->spinBox1_9;
    valor[6][7]=this->spinBox2_9;
    valor[6][8]=this->spinBox3_9;
    valor[7][6]=this->spinBox4_9;
    valor[7][7]=this->spinBox5_9;
    valor[7][8]=this->spinBox6_9;
    valor[8][6]=this->spinBox7_9;
    valor[8][7]=this->spinBox8_9;
    valor[8][8]=this->spinBox9_9;  
    
    for (int i=0;i<3;i++) scores[i].puntuacio=-1;
}



void Form2::resoldre()
{
    this->habilitar(false);
    counter->stop();
    for (int i=0;i<9;i++) 
	for (int j=0;j<9;j++)
	{
	valor[i][j]->setSpecialValueText(NULL);
	valor[i][j]->setMinValue(solucio[i][j]);
	valor[i][j]->setMaxValue(solucio[i][j]);
	valor[i][j]->setValue(solucio[i][j]);
	valor[i][j]->setEnabled(false);
	valor[i][j]->setFont(QFont ( "Helvetica",12, QFont::Bold,FALSE));
	valor[i][j]->setPaletteBackgroundColor(Blau);
    }
}


void Form2::habilitar(bool m)
{
    this->pushButton1->setEnabled(m);
    this->jocComprovarAction->setEnabled(m);
    this->jocResoldreAction->setEnabled(m);
    if (m==false)  this->textLabel1->setText("sudoku Beta 0.3");
}


void genera_fitxer()
{
    char nomus[10];
    system("whoami>nom");
    ifstream nomusuari;
    nomusuari.open("nom");
    nomusuari.getline(nomus,10);  
    nomusuari.close();
    system("rm nom");
    ofstream fitxer;
    fitxer.open(".data");
    fitxer << dificultat << endl;
    for (int i=0;i<3;i++)
    {
	if (scores[i].puntuacio<0) {
	    for (int j=0;j<10;j++) scores[i].nom[j]=nomus[j];
	    scores[i].puntuacio=0;
	}
	fitxer << scores[i].nom << " " << scores[i].puntuacio << endl;
    }
    fitxer.close();
}

void llig_fitxer(){
    ifstream fitxer;
    fitxer.open(".data");
    if (!fitxer) {fitxer.close(); genera_fitxer(); fitxer.open(".data");}
    fitxer >> dificultat;
    for (int i=0;i<3;i++) fitxer >> scores[i].nom >> scores[i].puntuacio;
    fitxer.close();    
}

